diff --git a/shell.py b/shell.py
index 999bffc..00b6896 100644
--- a/shell.py
+++ b/shell.py
@@ -26,13 +26,11 @@ import logging
 from yum import Errors
 from yum.constants import *
 import yum.logginglevels as logginglevels
-
+from yum.i18n import to_utf8
+import __builtin__
 
 class YumShell(cmd.Cmd):
-
-    """
-    Interactive yum shell.
-    """
+    """A class to implement an interactive yum shell."""
 
     def __init__(self, base):
         cmd.Cmd.__init__(self)
@@ -75,8 +73,39 @@ class YumShell(cmd.Cmd):
                 raise Errors.YumBaseError, "Fatal error in script, exiting"
         
         return inputs
-        
+
+    def cmdloop(self, *args, **kwargs):
+        """ Sick hack for readline. """
+
+        oraw_input = raw_input
+        owriter    = sys.stdout
+        _ostdout   = owriter.stream
+
+        def _sick_hack_raw_input(prompt):
+            sys.stdout = _ostdout
+            rret = oraw_input(to_utf8(prompt))
+            sys.stdout = owriter
+
+            return rret
+
+        __builtin__.raw_input = _sick_hack_raw_input
+
+        try:
+            cret = cmd.Cmd.cmdloop(self, *args, **kwargs)
+        except:
+            __builtin__.raw_input  = oraw_input
+            raise
+
+        __builtin__.raw_input = oraw_input
+
+        return cret
+
     def script(self):
+        """Execute a script file in the yum shell.  The location of
+        the script file is supplied by the :class:`cli.YumBaseCli`
+        object that is passed as a parameter to the :class:`YumShell`
+        object when it is created.
+        """
         try:
             fd = open(self.file, 'r')
         except IOError:
@@ -90,6 +119,13 @@ class YumShell(cmd.Cmd):
         return True
             
     def default(self, line):
+        """Handle the next line of input if there is not a dedicated
+        method of :class:`YumShell` to handle it.  This method will
+        handle yum commands that are not unique to the shell, such as
+        install, erase, etc.
+
+        :param line: the next line of input
+        """
         if len(line) > 0 and line.strip()[0] == '#':
             pass
         else:
@@ -117,9 +153,15 @@ class YumShell(cmd.Cmd):
                 self.base.doCommands()
     
     def emptyline(self):
+        """Do nothing on an empty line of input."""
         pass
 
     def completenames(self, text, line, begidx, endidx):
+        """Return a list of possible completions of a command.
+
+        :param text: the command to be completed
+        :return: a list of possible completions of the command
+        """
         ret = cmd.Cmd.completenames(self, text, line, begidx, endidx)
         for command in self.base.yum_cli_commands:
             if command.startswith(text) and command != "shell":
@@ -127,6 +169,11 @@ class YumShell(cmd.Cmd):
         return ret
 
     def do_help(self, arg):
+        """Output help information.
+
+        :param arg: the command to output help information about. If
+           *arg* is an empty string, general help will be output.
+        """
         msg = """
     Shell specific arguments:
       config - set config options
@@ -166,21 +213,47 @@ class YumShell(cmd.Cmd):
         self.verbose_logger.info(msg)
         
     def do_EOF(self, line):
+        """Exit the shell when EOF is reached.
+
+        :param line: unused
+        """
         self.resultmsgs = ['Leaving Shell']
         return True
     
     def do_quit(self, line):
+        """Exit the shell.
+
+        :param line: unused
+        """
         self.resultmsgs = ['Leaving Shell']
         return True
     
     def do_exit(self, line):
+        """Exit the shell.
+
+        :param line: unused
+        """
         self.resultmsgs = ['Leaving Shell']
         return True
     
     def do_ts(self, line):
+        """Handle the ts alias of the :func:`do_transaction` method.
+
+        :param line: the remainder of the line, containing the name of
+           a subcommand.  If no subcommand is given, run the list subcommand.
+        """
         self.do_transaction(line)
 
     def do_transaction(self, line):
+        """Execute the given transaction subcommand.  The list
+        subcommand outputs the contents of the transaction, the reset
+        subcommand clears the transaction, the solve subcommand solves
+        dependencies for the transaction, and the run subcommand
+        executes the transaction.
+
+        :param line: the remainder of the line, containing the name of
+           a subcommand.  If no subcommand is given, run the list subcommand.
+        """
         (cmd, args, line) = self.parseline(line)
         if cmd in ['list', None]:
             self.verbose_logger.log(logginglevels.INFO_2,
@@ -210,6 +283,15 @@ class YumShell(cmd.Cmd):
             self.do_help('transaction')
     
     def do_config(self, line):
+        """Configure yum shell options.
+        
+        :param line: the remainder of the line, containing an option,
+           and then optionally a value in the form [option] [value].
+           Valid options are one of the following: debuglevel,
+           errorlevel, obsoletes, gpgcheck, assumeyes, exclude.  If no
+           value is given, print the current value.  If a value is
+           supplied, set the option to the given value.
+        """
         (cmd, args, line) = self.parseline(line)
         # logs
         if cmd in ['debuglevel', 'errorlevel']:
@@ -264,9 +346,23 @@ class YumShell(cmd.Cmd):
             self.do_help('config')
 
     def do_repository(self, line):
+        """Handle the repository alias of the :func:`do_repo` method.
+
+        :param line: the remainder of the line, containing the name of
+           a subcommand.
+        """
         self.do_repo(line)
         
     def do_repo(self, line):
+        """Execute the given repo subcommand.  The list subcommand
+        lists repositories and their statuses, the enable subcommand
+        enables the given repository, and the disable subcommand
+        disables the given repository.
+
+        :param line: the remainder of the line, containing the name of
+           a subcommand and other parameters if required.  If no
+           subcommand is given, run the list subcommand.
+        """
         (cmd, args, line) = self.parseline(line)
         if cmd in ['list', None]:
             # Munge things to run the repolist command
@@ -338,6 +434,10 @@ class YumShell(cmd.Cmd):
         print line
         
     def do_run(self, line):
+        """Run the transaction.
+
+        :param line: unused
+        """
         if len(self.base.tsInfo) > 0:
             try:
                 (code, msgs) = self.base.buildTransaction()
diff --git a/test/check-po-yes-no.py b/test/check-po-yes-no.py
index e22318e..b8f3406 100755
--- a/test/check-po-yes-no.py
+++ b/test/check-po-yes-no.py
@@ -6,7 +6,12 @@
 import sys
 import glob
 
-from yum.misc import to_utf8
+# Don't import from yum, as it isn't there when we are distro. building...
+def to_utf8(obj, errors='replace'):
+    '''convert 'unicode' to an encoded utf-8 byte string '''
+    if isinstance(obj, unicode):
+        obj = obj.encode('utf-8', errors)
+    return obj
 
 def trans(msg, default):
     if msg == 'msgstr ""\n':
@@ -16,6 +21,8 @@ def trans(msg, default):
         msg = msg[:-2]
     return unicode(msg, encoding='utf-8')
 
+allow_plain_yn = True
+
 for fname in glob.glob("po/*.po"):
     next = None
     is_this_ok  = None
@@ -32,7 +39,8 @@ for fname in glob.glob("po/*.po"):
         if next is not None:
             if next == 'is_this_ok':
                 sis_this_ok = line
-                if line == 'msgstr ""\n' or line.find('[y/N]') != -1:
+                if line == 'msgstr ""\n' or (not allow_plain_yn and
+                                             line.find('[y/N]') != -1):
                     is_this_ok = False
                 else:
                     is_this_ok = True
@@ -62,9 +70,9 @@ for fname in glob.glob("po/*.po"):
             next = 'n'
     if (is_this_ok is None or
         yes is None or
-        y   is None or
+        (not allow_plain_yn and y   is None) or
         no  is None or
-        n   is None):
+        (not allow_plain_yn and n   is None)):
         print >>sys.stderr, """\
 ERROR: Can't find all the msg id's in %s
 is_this_ok %s
@@ -96,6 +104,10 @@ n          %5s: %s
        to_utf8(is_this_ok), to_utf8(sis_this_ok),
        to_utf8(yes), to_utf8(syes), to_utf8(y), to_utf8(sy),
        to_utf8(no), to_utf8(sno), to_utf8(n), to_utf8(sn))
+
+    if allow_plain_yn:
+        continue
+
     if syes[0] != sy:
         print >>sys.stderr, """\
 ERROR: yes/y translations don't match in: %s
diff --git a/test/depsolvetests.py b/test/depsolvetests.py
index 7af3f16..ea47b03 100644
--- a/test/depsolvetests.py
+++ b/test/depsolvetests.py
@@ -1130,9 +1130,10 @@ class DepsolveTests(DepsolveTests):
         # FIXME: Does it make sense to ignore the obsoletes here? esp. as we
         # don't ignore the conflicts above? ... I'm guessing ignoring it is
         # by accident too? bah.
-        # self.assertEquals('err', *self.resolveCode())
-        self.assertEquals('ok', *self.resolveCode())
-        self.assertResult((ipo1, po1))
+        self.assertEquals('err', *self.resolveCode())
+        # Old behaviour:
+        # self.assertEquals('ok', *self.resolveCode())
+        # self.assertResult((ipo1, po1))
 
     def testUpdate_so_req_diff_arch(self):
         rpo1 = FakePackage('foozoomer')
diff --git a/test/misc-tests.py b/test/misc-tests.py
index d34c161..11fd041 100644
--- a/test/misc-tests.py
+++ b/test/misc-tests.py
@@ -114,6 +114,55 @@ class MiscTests(DepsolveTests):
         res, msg = solver.buildTransaction()
         return self.res[res], msg
 
+    def testXML(self):
+        import yum.misc
+        for args in (
+
+# valid utf8 and unicode
+('\xc4\x9b\xc5\xa1\xc4\x8d', '\xc4\x9b\xc5\xa1\xc4\x8d'),
+(u'\u011b\u0161\u010d',      '\xc4\x9b\xc5\xa1\xc4\x8d'),
+
+# invalid utf8
+('\xc3\x28', '\xc3\x83\x28'),
+('\xa0\xa1', '\xc2\xa0\xc2\xa1'),
+('Skytt\xe4', 'Skytt\xc3\xa4'),
+
+# entity expansion
+('&<>', '&amp;&lt;&gt;'),
+
+# removal of invalid bytes
+('\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f', '\t\n\r'),
+
+# attr flag
+('&"\'', '&amp;"\''),
+('&"\'', True, '&amp;&quot;&apos;'),
+
+# weirdness
+(None, ''),
+('abc ', 'abc'),
+
+        ):
+            # last item is the expected result
+            args, expected = args[:-1], args[-1]
+            actual = yum.misc.to_xml(*args)
+
+            # actual vs expected
+            self.assertEqual(type(actual), type(expected))
+            self.assertEqual(actual, expected)
+
+    def testOptparse(self):
+        # make 'Usage: %s\n' translated
+        import gettext
+        def dgettext(domain, msg, orig=gettext.dgettext):
+            if domain=='messages' and msg == 'Usage: %s\n':
+                return 'Pou\xc5\xbeit\xc3\xad: %s\n'
+            return orig(domain, msg)
+        gettext.dgettext = dgettext
+        # run "yum --help"
+        from optparse import OptionParser
+        parser = OptionParser(usage=u'\u011b\u0161\u010d')
+        self.assertRaises(SystemExit, parser.parse_args, args=['--help'])
+
 def setup_logging():
     logging.basicConfig()    
     plainformatter = logging.Formatter("%(message)s")    
diff --git a/test/revdepupdatetests.py b/test/revdepupdatetests.py
new file mode 100644
index 0000000..a98341d
--- /dev/null
+++ b/test/revdepupdatetests.py
@@ -0,0 +1,70 @@
+from testbase import *
+
+class RevdepUpdateTests(OperationsTests):
+
+    @staticmethod
+    def buildPkgs(pkgs, *args):
+        """ This test checks that remove_old_deps handles reverse 
+        dependencies properly during yum update. Specifically, 
+        remove_old_deps should remove precisely the packages which are not 
+        required by any package currently installed or pending 
+        installation. Two cases:
+        
+        For packages A, B, we write A -> B if B requires A. Packages 
+        with a dep prefix are dep-installed.
+
+        1) Installed: dep1 -> dep2 -> pkg1 <- dep3 and dep3 -> dep2
+           Update: pkg1, which requires dep2 but no longer requires dep3.
+           Correct outcome: dep1, dep2, dep3, pkg1, since dep2 still 
+           needs dep3.
+
+        2) Installed: dep1 -> dep2 -> pkg1 <- dep3 and dep3 -> dep2
+           Update: pkg1, which now requires only dep1
+           Correct outcome: dep1, pkg1, since dep2 and dep3 are 
+           no longer needed.
+           
+        """
+
+        
+        pkgs.installed_1 = FakePackage('dep1', '1', '0', '0', 'noarch')
+        pkgs.installed_1.yumdb_info.reason = 'dep'
+        
+        pkgs.installed_2 = FakePackage('dep2', '1', '0', '0', 'noarch')
+        pkgs.installed_2.yumdb_info.reason = 'dep'
+        
+        pkgs.installed_3 = FakePackage('pkg1', '1', '0', '0', 'noarch')
+        pkgs.installed_3.yumdb_info.reason = 'user'
+
+        pkgs.installed_4 = FakePackage('dep3', '1', '0', '0', 'noarch')
+        pkgs.installed_4.yumdb_info.reason = 'dep'
+        
+        pkgs.installed_1.addRequiringPkg(pkgs.installed_2)
+        pkgs.installed_2.addRequiringPkg(pkgs.installed_3)
+        pkgs.installed_4.addRequiringPkg(pkgs.installed_2)
+
+        pkgs.installed_2.addRequiresPkg(pkgs.installed_1)
+        pkgs.installed_2.addRequiresPkg(pkgs.installed_4)
+        pkgs.installed_3.addRequiresPkg(pkgs.installed_4)
+        pkgs.installed_3.addRequiresPkg(pkgs.installed_2)
+
+        pkgs.update_2 = FakePackage('dep2', '2', '0', '0', 'noarch')
+        pkgs.update_2.addRequires('dep1', 'EQ', ('0', '1', '0'))
+
+        pkgs.update_3 = FakePackage('pkg1', '2', '0', '0', 'noarch')
+        pkgs.update_3.addRequires('dep2', 'EQ', ('0', '1', '0'))
+
+        pkgs.update_4 = FakePackage('pkg1', '2', '0', '0', 'noarch')
+        pkgs.update_4.addRequires('dep1', 'EQ', ('0', '1', '0'))
+
+    def testUpdate(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['update'], [p.installed_1, p.installed_2, p.installed_3, p.installed_4], [p.update_3])
+        self.assert_(res=='ok', msg)
+        self.assertResult( (p.installed_1, p.installed_2, p.update_3, p.installed_4) )
+    
+    def testUpdate2(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['update'], [p.installed_1, p.installed_2, p.installed_3, p.installed_4], [p.update_4])
+        self.assert_(res=='ok', msg)
+        self.assertResult( (p.installed_1, p.update_4) )
+
diff --git a/test/simpleobsoletestests.py b/test/simpleobsoletestests.py
index 97a9923..6cede1e 100644
--- a/test/simpleobsoletestests.py
+++ b/test/simpleobsoletestests.py
@@ -244,6 +244,40 @@ class SimpleObsoletesTests(OperationsTests):
         self.assert_(res=='ok', msg)
         self.assertResult((p.obsoletes_noarch,))
 
+    def testObsoletesOffPostInst1(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['install', 'zsh'], [p.obsoletes_i386], [p.installed_i386])
+        self.assert_(res=='empty', msg)
+
+    def testObsoletesOffPostInst2(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['install', 'zsh'], [p.obsoletes_i386], [p.installed_i386], {'obsoletes' : False})
+        self.assert_(res=='empty', msg)
+
+    def testObsoletesOffPostAvail1(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['install', 'zsh-ng', 'zsh'], [], [p.obsoletes_i386, p.installed_i386])
+        self.assert_(res=='ok', msg)
+        self.assertResult((p.obsoletes_i386,))
+
+    def testObsoletesOffPostAvail2(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['install', 'zsh-ng', 'zsh'], [], [p.obsoletes_i386, p.installed_i386], {'obsoletes' : False})
+        self.assert_(res=='ok', msg)
+        self.assertResult((p.obsoletes_i386,))
+
+    def testObsoletesOffPostAvail3(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['install', 'zsh', 'zsh-ng'], [], [p.obsoletes_i386, p.installed_i386])
+        self.assert_(res=='ok', msg)
+        self.assertResult((p.obsoletes_i386,))
+
+    def testObsoletesOffPostAvail4(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['install', 'zsh', 'zsh-ng'], [], [p.obsoletes_i386, p.installed_i386], {'obsoletes' : False})
+        self.assert_(res=='ok', msg)
+        self.assertResult((p.obsoletes_i386,))
+
     def _MultiObsHelper(self):
         ret = {'zsh'  : FakePackage('zsh', '1', '1', '0', 'noarch'),
                'ksh'  : FakePackage('ksh', '1', '1', '0', 'noarch'),
@@ -588,6 +622,152 @@ class SimpleObsoletesTests(OperationsTests):
         # self.assert_(res=='err', msg)
         self.assertResult([])
 
+    def testRLOpenSSLMess1(self):
+        osl1  = FakePackage('openssl',      '1.0.0', '1', arch='i386')
+        osl1.addProvides('libssl.1', 'EQ', ('0', '1', '1'))
+        osl2  = FakePackage('openssl',      '1.0.1', '1', arch='i386')
+        osll2 = FakePackage('openssl-libs', '1.0.1', '1', arch='i386')
+        osll2.addProvides('libssl.2', 'EQ', ('0', '2', '1'))
+        osll2.addObsoletes('openssl', 'LT', (None, '1.0.1', None))
+
+        oc1   = FakePackage('openconnect',  '2.0.1', '1', arch='i386')
+        oc1.addRequires('openssl', 'GE', ('0', '0.9.9', '1'))
+        oc2   = FakePackage('openconnect',  '2.0.2', '1', arch='i386')
+        oc2.addRequires('openssl', 'GE', ('0', '0.9.9', '1'))
+
+        res, msg = self.runOperation(['upgrade', 'openssl'],
+                                     [oc1, osl1],
+                                     [oc1, oc2, osl1, osl2, osll2])
+
+        # In theory don't need to upgrade oc1 => oc2
+        self.assertResult((oc2, osl2, osll2))
+
+    def testCircObs1(self):
+        c1 = FakePackage('test-ccc', '0.1', '1')
+        c2 = FakePackage('test-ccc', '0.2', '2')
+        c2.addObsoletes('test-ddd', None, (None, None, None))
+
+        d1 = FakePackage('test-ddd', '0.1', '1')
+        d2 = FakePackage('test-ddd', '0.2', '2')
+        d2.addObsoletes('test-ccc', None, (None, None, None))
+
+        res, msg = self.runOperation(['upgrade'],
+                                     [c1, d1],
+                                     [c1, d1, c2, d2])
+
+        self.assertResult((c2, d2))
+
+    def testCircObs2(self):
+        c1 = FakePackage('test-ccc', '0.1', '1')
+        c2 = FakePackage('test-ccc', '0.2', '2')
+        c2.addObsoletes('test-ddd', None, (None, None, None))
+
+        d1 = FakePackage('test-ddd', '0.1', '1')
+        d2 = FakePackage('test-ddd', '0.2', '2')
+        d2.addObsoletes('test-ccc', None, (None, None, None))
+
+        res, msg = self.runOperation(['upgrade', 'test-ccc', 'test-ddd'],
+                                     [c1, d1],
+                                     [c1, d1, c2, d2])
+
+        self.assertResult((c2, d2))
+
+    def testCircObs3(self):
+        c1 = FakePackage('test-ccc', '0.1', '1')
+        c2 = FakePackage('test-ccc', '0.2', '2')
+        c2.addObsoletes('test-ddd', None, (None, None, None))
+
+        d1 = FakePackage('test-ddd', '0.1', '1')
+        d2 = FakePackage('test-ddd', '0.2', '2')
+        d2.addObsoletes('test-ccc', None, (None, None, None))
+
+        res, msg = self.runOperation(['upgrade', 'test-ccc'],
+                                     [c1, d1],
+                                     [c1, d1, c2, d2])
+
+        # Just c2 is fine too, although less likely what the user wants
+        self.assertResult((c2,d2))
+
+    def testCircObs4(self):
+        c1 = FakePackage('test-ccc', '0.1', '1')
+        c2 = FakePackage('test-ccc', '0.2', '2')
+        c2.addObsoletes('test-ddd', None, (None, None, None))
+
+        d1 = FakePackage('test-ddd', '0.1', '1')
+        d2 = FakePackage('test-ddd', '0.2', '2')
+        d2.addObsoletes('test-ccc', None, (None, None, None))
+
+        res, msg = self.runOperation(['upgrade', 'test-ddd'],
+                                     [c1, d1],
+                                     [c1, d1, c2, d2])
+
+        # Just d2 is fine too, although less likely what the user wants
+        self.assertResult((c2,d2))
+
+    def testRLFileReqTransObs1(self):
+        fr1 = FakePackage('fr1', '1', '1')
+        fr1.addRequires('/foo')
+        fr2 = FakePackage('fr2', '2', '2')
+
+        fp1 = FakePackage('fp1', '1', '2')
+        fp1.addFile('/foo')
+        fp2 = FakePackage('fpl2', '1', '2')
+        fp2.addFile('/foo')
+
+        ob1 = FakePackage('ob1', '1', '3')
+        ob1.addObsoletes('fp1', None, (None, None, None))
+
+        res, msg = self.runOperation(['install', 'ob1', 'fr1'], [],
+                                     [fr1, fr2, fp1, fp2, ob1])
+
+        self.assert_(res=='err', msg)
+        # Should really be:
+        # self.assertResult([ob1, fr1, fp2])
+
+    def testRLFileReqTransObs2(self):
+        fr1 = FakePackage('fr1', '1', '1')
+        fr1.addRequires('/foo')
+        fr2 = FakePackage('fr2', '2', '2')
+        fr2.addRequires('/bar')
+
+        fp1 = FakePackage('fp1', '1', '2')
+        fp1.addFile('/foo')
+        fp2 = FakePackage('fpl2', '1', '2')
+        fp2.addFile('/foo')
+
+        ob1 = FakePackage('ob1', '1', '3')
+        ob1.addObsoletes('fp1', None, (None, None, None))
+        ob1.addFile('/bar')
+
+        res, msg = self.runOperation(['install', 'fr1', 'fr2'], [],
+                                     [fr1, fr2, fp1, fp2, ob1])
+
+        self.assert_(res=='err', msg)
+        # Should really be:
+        # self.assertResult([ob1, fr1, fp2])
+
+    def testRLFileReqInstObs(self):
+        fr1 = FakePackage('fr1', '1', '1')
+        fr1.addRequires('/foo')
+        fr2 = FakePackage('fr2', '2', '2')
+
+        fp1 = FakePackage('fp1', '1', '2')
+        fp1.addFile('/foo')
+        fp2 = FakePackage('fpl2', '1', '2')
+        fp2.addFile('/foo')
+
+        ob1 = FakePackage('ob1', '1', '3')
+        ob1.addObsoletes('fp1', None, (None, None, None))
+
+        res, msg = self.runOperation(['install', 'fr1'], [ob1],
+                                     [fr1, fr2, fp1, fp2, ob1])
+        print "JDBG:", "test:", res, msg
+
+        self.assert_(res=='err', msg)
+        # Should really be:
+        # self.assertResult([ob1, fr1, fp2])
+
+
 class GitMetapackageObsoletesTests(OperationsTests):
 
     @staticmethod
